# Expert Directory/Search

{% hint style="info" %}
Remember to change **:corporation** with your corporation id(found in the integrations section of the dashboard).
{% endhint %}

## Listing Experts

<mark style="color:green;">`GET`</mark> [**/v2/organization/:corporation/expert**](https://public-api.expertfile.com/v2/organization/:corporation/expert)

**Headers**

| Name          | Value              |
| ------------- | ------------------ |
| Content-Type  | `application/json` |
| Authorization | `Bearer <token>`   |

**Url**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>corporation</td><td>number</td><td>Corporation ID</td></tr><tr><td>username</td><td>string</td><td>Unique username</td></tr><tr><td>q</td><td>string</td><td>Keyword search term</td></tr><tr><td>access</td><td>string</td><td>public/private/all</td></tr><tr><td>status</td><td>string</td><td>published/unpublished/all</td></tr><tr><td>page_size</td><td>number</td><td>Size of page</td></tr><tr><td>page_from</td><td>number</td><td>Starting point</td></tr><tr><td>countries</td><td>string</td><td>Filter by country. Array of countries(i.e. ["CA","US"])<br>See full list <a href="/pages/eqgpZlI3h1xoH0tJmVdw#country-codes"><em><strong>here</strong></em></a></td></tr><tr><td>topics</td><td>string</td><td>Filter by topics. Array of topics(i.e. ["topic1","topic2"])</td></tr><tr><td>industries</td><td>string</td><td>Filter by industries. Array of industries(i.e. ["industry1","industry2"])</td></tr><tr><td>categories</td><td>string</td><td>Filter by categories. Array of categories(i.e. ["cat1","cat2"])</td></tr><tr><td>tags</td><td>string</td><td>Filter by tags. Array of tags(i.e. ["tag1","tag2"])</td></tr><tr><td>fields</td><td>string</td><td><p>Array of field name(i.e. ["fullname","username"]) </p><p>See full list <a href="/pages/eqgpZlI3h1xoH0tJmVdw#return-fields"><em><strong>here</strong></em></a></p></td></tr><tr><td>sort</td><td>string</td><td>Sorting order(name/featured)</td></tr><tr><td>searchfield</td><td>string</td><td>Fullname to query only name field.</td></tr></tbody></table>

**Response**

{% tabs %}
{% tab title="200" %}

```json
{
  data: {
    experts: [],
    aggregations: {
      has_uploaded_video: [],
      has_vimeo_video: [],
      has_slideshare_document: [],
      topics: [],
      countries: [],
      has_photo: [],
      states: [],
      has_uploaded_podchaser: [],
      has_book: [],
      companies: [],
      industries: [ay],
      has_youtube_video: [],
      classification_tags: [],
      profiles: [],
      has_profile: [],
      has_uploaded_document: [],
      classification_categories: [],
      alpha: []
    },
    total: 10
  },
  success: true
}  
```

{% endtab %}
{% endtabs %}

**Code**

{% tabs %}
{% tab title="Node" %}

```javascript
const accessToken = `<ACCESS TOKEN>`

fetch('https://public-api.expertfile.com/v2/organization/:corporation/expert', {
    method: 'GET',
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': `Bearer ${accessToken}`
    }
})
.then(response => response.json())
.then(json => {
    const { success, data } = json

    if (success) {
        const { experts, aggregations } = data;
        console.log('Experts', experts);
        console.log('Filters', aggregations);
    }

})
.catch(error => console.error(error));
```

{% endtab %}

{% tab title="PHP" %}

```php
$accessToken = urlencode('<ACCESS TOKEN>');
$url = 'https://public-api.expertfile.com/v2/organization/:corporation/expert';

$ch = curl_init($url);
curl_setopt(
    $ch,
    CURLOPT_HTTPHEADER,
    array('Content-Type: application/x-www-form-urlencoded', 'Authorization: Bearer ' . $accessToken)
);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

$response = curl_exec($ch);
$json = json_decode($response);

if($json->success){
    var_dump($json->data);
}

curl_close($ch);

```

{% endtab %}

{% tab title="Curl" %}

```
curl https://public-api.expertfile.com/v2/organization/:corporation/expert \
    -H "Content-Type: application/json" \
    -H "Authorization: Bearer <ACCESS TOKEN>"
```

{% endtab %}
{% endtabs %}

## Applying Category Filter to Experts

<mark style="color:green;">`GET`</mark> [**/v2/organization/:corporation/expert**](https://public-api.expertfile.com/v2/organization/:corporation/expert)

**Headers**

| Name          | Value              |
| ------------- | ------------------ |
| Content-Type  | `application/json` |
| Authorization | `Bearer <token>`   |

**Url**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>corporation</td><td>number</td><td>Corporation ID</td></tr><tr><td>categories</td><td>string</td><td>Filter by categories. Array of categories(i.e. ["cat1","cat2"])</td></tr></tbody></table>

**Response**

{% tabs %}
{% tab title="200" %}

```json
{
  data: {
    experts: [],
    aggregations: {
      has_uploaded_video: [],
      has_vimeo_video: [],
      has_slideshare_document: [],
      topics: [],
      countries: [],
      has_photo: [],
      states: [],
      has_uploaded_podchaser: [],
      has_book: [],
      companies: [],
      industries: [],
      has_youtube_video: [],
      classification_tags: [],
      profiles: [],
      has_profile: [],
      has_uploaded_document: [],
      classification_categories: [],
      alpha: []
    },
    total: 10
  },
  success: true
}  
```

{% endtab %}
{% endtabs %}

**Code**

{% tabs %}
{% tab title="Node" %}

```javascript
const accessToken = `<ACCESS TOKEN>`

const params = {
    categories: JSON.stringify(['Advisors', 'Featured'])
};

const qs = new URLSearchParams(params).toString()

const path = `https://public-api.expertfile.com/v2/organization/:corporation/expert${qs ? '?' + qs : ''}`
fetch(path, {
    method: 'GET',
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': `Bearer ${accessToken}`
    }
})
.then(response => response.json())
.then(json => {
    const { success, data } = json

    if (success) {
        const { experts, aggregations } = data;
        console.log('Experts', experts);
        console.log('Filters', aggregations);
    }

})
.catch(error => console.error(error));
```

{% endtab %}

{% tab title="PHP" %}

```php
$accessToken = urlencode('<ACCESS CODE>');
$parameters = array(
    'categories' => json_encode(['Advisors', 'Featured'])
);

$url = 'https://public-api.expertfile.com/v2/organization/:corporation/expert?' . http_build_query($parameters);

$ch = curl_init($url);
curl_setopt(
    $ch,
    CURLOPT_HTTPHEADER,
    array('Content-Type: application/x-www-form-urlencoded', 'Authorization: Bearer ' . $accessToken)
);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

$response = curl_exec($ch);
$json = json_decode($response);

if($json->success){
    var_dump($json->data);
}

curl_close($ch);
```

{% endtab %}

{% tab title="Curl" %}

```
curl --GET \
--data-urlencode 'categories=["Advisors","Featured"]' \
https://public-api.expertfile.com/v2/organization/:corporation/expert \
-H "Content-Type: application/json" \
-H "Authorization: Bearer <ACCESS CODE>"
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developer.expertfile.com/reference/api-reference/experts/expert-directory-search.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
